import soundfile as sf
import numpy as np
import cv2
infile='path-to-image.jpg'
band_height=203
padding_value=114
sample_rate=48000
stereo=2 #0 for mono, 1 for interleaved samples, 2 for reflective/symmetrical
inimage=cv2.imread(infile).astype('float64')
imheight=inimage.shape[0]
imwidth=inimage.shape[1]
if(stereo==2):
    cyclerange=2
else:
    cyclerange=1
for cycle in range(cyclerange):
    if(stereo==2):
        if(cycle==0):
            inimagetemp=np.fliplr(inimage[:,0:int((inimage.shape[1]/2)),:])
        else:
            inimagetemp=inimage[:,(int(inimage.shape[1]/2)):,:]
    else:
        inimagetemp=inimage  
    for chunk in range(0,int(imheight/band_height)):
        startrow=chunk*band_height
        endrow=((chunk+1)*band_height)
        imbit=inimagetemp[startrow:endrow,:,0]-inimagetemp[startrow:endrow,:,1]
        imbit=imbit.flatten('F')
        if chunk==0:
            outarray=imbit[0:imbit.shape[0]-padding_value]
        else:
            outarray=np.hstack((outarray,imbit[0:imbit.shape[0]-padding_value]))       
    if stereo==2 and cycle==1:
        outarrayfin=np.vstack((outarrayfin,outarray))
        outarrayfin=outarrayfin.transpose()
    else:
        outarrayfin=outarray   
if(stereo==1):
    outarrayfin=outarrayfin.reshape(2,(int(outarrayfin.shape[0]/2)))
outarrayfin=(outarrayfin/np.max(outarrayfin))
sf.write(infile+'.wav',outarrayfin.astype('float64'),sample_rate)